/*
 * The contents of this file are subject to the terms of the Common Development
 * and Distribution License (the License). You may not use this file except in
 * compliance with the License.
 *
 * You can obtain a copy of the License at http://www.netbeans.org/cddl.html
 * or http://www.netbeans.org/cddl.txt.

 * When distributing Covered Code, include this CDDL Header Notice in each file
 * and include the License file at http://www.netbeans.org/cddl.txt.
 * If applicable, add the following below the CDDL Header, with the fields
 * enclosed by brackets [] replaced by your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2006 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.encoder.ui.basic;

/**
 * The confirmation dialog before applying encoding settings.
 *
 * @author  Jun Xu
 */
public class RemoveEncodingConfirmation extends javax.swing.JPanel {
    
    /** Creates new form ApplyEncodingConfirmation */
    public RemoveEncodingConfirmation() {
        initComponents();
    }
    
    public boolean isApplyToReferenced() {
        return applyToAllCheckBox.isSelected();
    }
    
    public void setApplyToReferenced(boolean value) {
        applyToAllCheckBox.setSelected(value);
    }

    public boolean contains(int x, int y) {
        return true;
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {

        applyToAllCheckBox = new javax.swing.JCheckBox();
        descriptionLabel = new javax.swing.JLabel();
        warningLabel = new javax.swing.JLabel();

        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("org/netbeans/modules/encoder/ui/basic/Bundle"); // NOI18N
        applyToAllCheckBox.setText(bundle.getString("remove_enc_conf.lbl.apply_to_ref_schemas")); // NOI18N
        applyToAllCheckBox.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        applyToAllCheckBox.setMargin(new java.awt.Insets(0, 0, 0, 0));

        descriptionLabel.setText(bundle.getString("remove_enc_conf.lbl.warn_modify_ref_schemas")); // NOI18N

        warningLabel.setText(bundle.getString("remove_enc_conf.lbl.deletion_confirm")); // NOI18N

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(warningLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 407, Short.MAX_VALUE)
                        .addContainerGap())
                    .add(layout.createSequentialGroup()
                        .add(applyToAllCheckBox, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 362, Short.MAX_VALUE)
                        .add(60, 60, 60))
                    .add(layout.createSequentialGroup()
                        .add(descriptionLabel)
                        .addContainerGap(34, Short.MAX_VALUE))))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .add(warningLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 28, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(applyToAllCheckBox)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(descriptionLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 24, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox applyToAllCheckBox;
    private javax.swing.JLabel descriptionLabel;
    private javax.swing.JLabel warningLabel;
    // End of variables declaration//GEN-END:variables
    
}
