/*
 * StoredProceduresPanel.java
 *
 * Created on August 11, 2008, 3:50 PM
 */
package org.netbeans.modules.wsdlextensions.jdbc.wizards;

import java.awt.Component;
import java.awt.Cursor;
import java.awt.Dialog;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.List;
import javax.swing.JTable;
import javax.swing.SwingUtilities;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.table.DefaultTableModel;
import org.netbeans.api.db.explorer.DatabaseConnection;
import org.netbeans.modules.wsdlextensions.jdbc.builder.DBMetaData;
import org.netbeans.modules.wsdlextensions.jdbc.builder.Procedure;
import org.netbeans.modules.wsdlextensions.jdbc.builder.ResultSetColumns;
import org.netbeans.modules.wsdlextensions.jdbc.builder.util.Utils;
import org.openide.ErrorManager;
import org.openide.NotifyDescriptor;
import org.openide.WizardDescriptor;
import org.openide.util.HelpCtx;
import org.openide.util.NbBundle;

/**
 *
 * @author  pponnala
 */
public class StoredProceduresPanel extends javax.swing.JPanel implements WizardDescriptor.Panel {

    private DefaultTableModel storedProcParamsModel;
    private DefaultTableModel storedProcResultsetModel;
    private DefaultTableModel storedProcTableListModel;
    private DefaultTableModel selectedStoredProcsModel;
    private ProcedureParametersDialog procedureParametersDialog;
    private ProcedureResultsetDialog procResultSetsDialog;
    private DatabaseConnection dbConn;
    private DBMetaData dbMeta;
    private Hashtable selectedProcList;
    private final List /* <ChangeListener> */ listeners = new ArrayList();
    private ArrayList<ResultSetColumns> resultsetMap; //ArrayList of resultsets.
    private StoredProcedureDescriptorPanel mWizardPanel = null;

    /** Creates new form StoredProceduresPanel */
    public StoredProceduresPanel(StoredProcedureDescriptorPanel wizardPanel,
            String title) {
        setName(title);
        mWizardPanel = wizardPanel;
        storedProcTableListModel = new DefaultTableModel(new Object[]{"Name", "Catalog", "Schema", "Procedure Type"}, 0);
        selectedStoredProcsModel = new DefaultTableModel(new Object[]{"Name", "Catalog", "Schema", "Procedure Type"}, 0);
        storedProcParamsModel = new DefaultTableModel(new Object[]{"Parameter Name", "Parameter Type"}, 0);
        storedProcResultsetModel = new DefaultTableModel(new Object[]{"Resultset Name, Resultset"}, 0);
        selectedProcList = new Hashtable();
        resultsetMap = new ArrayList();
        initComponents();
        //loadProcList();
    }

    void setConnection(DatabaseConnection connection) {
        this.dbConn = connection;
        this.dbMeta = new DBMetaData();
        //loadProcList();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane2 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        storedProcEditorLabel = new javax.swing.JLabel();
        procedureNamePatternLabel = new javax.swing.JLabel();
        procedureNamePatternTextField = new javax.swing.JTextField();
        searchProceduresButton = new javax.swing.JButton();
        procListLabel = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        storedProcTable = new JTable() {
            public boolean isCellEditable(int x, int y) {
                return false;
            }
        };
        btnSelectStoredProc = new javax.swing.JButton();
        procListLabel1 = new javax.swing.JLabel();
        jScrollPane5 = new javax.swing.JScrollPane();
        tblSelectedStoredProcs = new JTable() {
            public boolean isCellEditable(int x, int y) {
                return false;
            }
        };
        btnRemoveSP = new javax.swing.JButton();
        lblSelectedProcName = new javax.swing.JLabel();
        lblProcNumParameters = new javax.swing.JLabel();
        editParamsButton = new javax.swing.JButton();
        lblProcNumResultsets = new javax.swing.JLabel();
        btnEditResultsets = new javax.swing.JButton();
        statusLabel = new javax.swing.JLabel();
        jScrollPane3 = new javax.swing.JScrollPane();
        storedProcStatusText = new javax.swing.JTextArea();
        catalogPatternLabel = new javax.swing.JLabel();
        catalogPatternTextField = new javax.swing.JTextField();
        catalogPatternNull = new javax.swing.JCheckBox();

        jScrollPane2.setBorder(null);
        jScrollPane2.setHorizontalScrollBarPolicy(javax.swing.ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
        jScrollPane2.setVerticalScrollBarPolicy(javax.swing.ScrollPaneConstants.VERTICAL_SCROLLBAR_NEVER);
        jScrollPane2.setName("jScrollPane2"); // NOI18N

        jTextArea1.setColumns(20);
        jTextArea1.setRows(5);
        jTextArea1.setText(org.openide.util.NbBundle.getMessage(StoredProceduresPanel.class, "StoredProceduresPanel.jTextArea1.text")); // NOI18N
        jTextArea1.setName("jTextArea1"); // NOI18N
        jScrollPane2.setViewportView(jTextArea1);

        setName(org.openide.util.NbBundle.getMessage(StoredProceduresPanel.class, "StoredProceduresPanel.form.name")); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(storedProcEditorLabel, org.openide.util.NbBundle.getMessage(StoredProceduresPanel.class, "StoredProceduresPanel.storedProcEditorLabel.text")); // NOI18N
        storedProcEditorLabel.setName("storedProcEditorLabel"); // NOI18N

        procedureNamePatternLabel.setLabelFor(procedureNamePatternTextField);
        org.openide.awt.Mnemonics.setLocalizedText(procedureNamePatternLabel, org.openide.util.NbBundle.getMessage(StoredProceduresPanel.class, "StoredProceduresPanel.procedureNamePatternLabel.text")); // NOI18N
        procedureNamePatternLabel.setName("procedureNamePatternLabel"); // NOI18N

        procedureNamePatternTextField.setName("procedureNamePatternTextField"); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(searchProceduresButton, org.openide.util.NbBundle.getMessage(StoredProceduresPanel.class, "StoredProceduresPanel.searchProceduresButton.text")); // NOI18N
        searchProceduresButton.setName("searchProceduresButton"); // NOI18N
        searchProceduresButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                searchProceduresButtonActionPerformed(evt);
            }
        });

        procListLabel.setFont(new java.awt.Font("Tahoma", 1, 11));
        procListLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        procListLabel.setLabelFor(storedProcTable);
        org.openide.awt.Mnemonics.setLocalizedText(procListLabel, org.openide.util.NbBundle.getMessage(StoredProceduresPanel.class, "StoredProceduresPanel.procListLabel.text")); // NOI18N
        procListLabel.setToolTipText(org.openide.util.NbBundle.getMessage(StoredProceduresPanel.class, "StoredProceduresPanel.procListLabel.toolTipText")); // NOI18N
        procListLabel.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        procListLabel.setName("procListLabel"); // NOI18N

        jScrollPane1.setName("jScrollPane1"); // NOI18N

        storedProcTable.setFont(storedProcTable.getFont());
        storedProcTable.setModel(storedProcTableListModel);
        storedProcTable.setToolTipText(org.openide.util.NbBundle.getMessage(StoredProceduresPanel.class, "StoredProceduresPanel.storedProcTable.toolTipText")); // NOI18N
        storedProcTable.setName("storedProcTable"); // NOI18N
        storedProcTable.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        jScrollPane1.setViewportView(storedProcTable);
        storedProcTable.getAccessibleContext().setAccessibleName(org.openide.util.NbBundle.getMessage(StoredProceduresPanel.class, "StoredProceduresPanel.storedProcTable.AccessibleContext.accessibleName")); // NOI18N
        storedProcTable.getAccessibleContext().setAccessibleDescription(org.openide.util.NbBundle.getMessage(StoredProceduresPanel.class, "StoredProceduresPanel.storedProcTable.AccessibleContext.accessibleDescription")); // NOI18N

        btnSelectStoredProc.setFont(btnSelectStoredProc.getFont());
        org.openide.awt.Mnemonics.setLocalizedText(btnSelectStoredProc, org.openide.util.NbBundle.getMessage(StoredProceduresPanel.class, "StoredProceduresPanel.btnSelectStoredProc.text")); // NOI18N
        btnSelectStoredProc.setToolTipText(org.openide.util.NbBundle.getMessage(StoredProceduresPanel.class, "StoredProceduresPanel.btnSelectStoredProc.toolTipText")); // NOI18N
        btnSelectStoredProc.setActionCommand(org.openide.util.NbBundle.getMessage(StoredProceduresPanel.class, "StoredProceduresPanel.btnSelectStoredProc.actionCommand")); // NOI18N
        btnSelectStoredProc.setName("btnSelectStoredProc"); // NOI18N
        btnSelectStoredProc.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSelectStoredProcActionPerformed(evt);
            }
        });

        procListLabel1.setFont(new java.awt.Font("Tahoma", 1, 11));
        procListLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        procListLabel1.setLabelFor(tblSelectedStoredProcs);
        org.openide.awt.Mnemonics.setLocalizedText(procListLabel1, org.openide.util.NbBundle.getMessage(StoredProceduresPanel.class, "StoredProceduresPanel.procListLabel1.text")); // NOI18N
        procListLabel1.setToolTipText(org.openide.util.NbBundle.getMessage(StoredProceduresPanel.class, "StoredProceduresPanel.procListLabel1.toolTipText")); // NOI18N
        procListLabel1.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        procListLabel1.setName("procListLabel1"); // NOI18N

        jScrollPane5.setName("jScrollPane5"); // NOI18N

        tblSelectedStoredProcs.setFont(tblSelectedStoredProcs.getFont());
        tblSelectedStoredProcs.setModel(selectedStoredProcsModel);
        tblSelectedStoredProcs.setName("tblSelectedStoredProcs"); // NOI18N
        tblSelectedStoredProcs.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        jScrollPane5.setViewportView(tblSelectedStoredProcs);

        btnRemoveSP.setFont(btnRemoveSP.getFont());
        org.openide.awt.Mnemonics.setLocalizedText(btnRemoveSP, org.openide.util.NbBundle.getMessage(StoredProceduresPanel.class, "StoredProceduresPanel.btnRemoveSP.text")); // NOI18N
        btnRemoveSP.setName("btnRemoveSP"); // NOI18N
        btnRemoveSP.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnRemoveSPActionPerformed(evt);
            }
        });

        lblSelectedProcName.setFont(new java.awt.Font("Tahoma", 1, 12));
        org.openide.awt.Mnemonics.setLocalizedText(lblSelectedProcName, org.openide.util.NbBundle.getMessage(StoredProceduresPanel.class, "StoredProceduresPanel.lblSelectedProcName.text")); // NOI18N
        lblSelectedProcName.setName("lblSelectedProcName"); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(lblProcNumParameters, org.openide.util.NbBundle.getMessage(StoredProceduresPanel.class, "StoredProceduresPanel.lblProcNumParameters.text")); // NOI18N
        lblProcNumParameters.setName("lblProcNumParameters"); // NOI18N

        editParamsButton.setFont(editParamsButton.getFont());
        org.openide.awt.Mnemonics.setLocalizedText(editParamsButton, org.openide.util.NbBundle.getMessage(StoredProceduresPanel.class, "StoredProceduresPanel.editParamsButton.text")); // NOI18N
        editParamsButton.setToolTipText(org.openide.util.NbBundle.getMessage(StoredProceduresPanel.class, "StoredProceduresPanel.editParamsButton.toolTipText")); // NOI18N
        editParamsButton.setName("editParamsButton"); // NOI18N
        editParamsButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                editParamsButtonActionPerformed(evt);
            }
        });

        org.openide.awt.Mnemonics.setLocalizedText(lblProcNumResultsets, org.openide.util.NbBundle.getMessage(StoredProceduresPanel.class, "StoredProceduresPanel.lblProcNumResultsets.text")); // NOI18N
        lblProcNumResultsets.setName("lblProcNumResultsets"); // NOI18N

        btnEditResultsets.setFont(btnEditResultsets.getFont());
        org.openide.awt.Mnemonics.setLocalizedText(btnEditResultsets, org.openide.util.NbBundle.getMessage(StoredProceduresPanel.class, "StoredProceduresPanel.btnEditResultsets.text")); // NOI18N
        btnEditResultsets.setToolTipText(org.openide.util.NbBundle.getMessage(StoredProceduresPanel.class, "StoredProceduresPanel.btnEditResultsets.toolTipText")); // NOI18N
        btnEditResultsets.setName("btnEditResultsets"); // NOI18N
        btnEditResultsets.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnEditResultsetsActionPerformed(evt);
            }
        });

        statusLabel.setFont(new java.awt.Font("Tahoma", 1, 11));
        statusLabel.setLabelFor(storedProcStatusText);
        org.openide.awt.Mnemonics.setLocalizedText(statusLabel, org.openide.util.NbBundle.getMessage(StoredProceduresPanel.class, "StoredProceduresPanel.statusLabel.text")); // NOI18N
        statusLabel.setName("statusLabel"); // NOI18N

        jScrollPane3.setName("jScrollPane3"); // NOI18N

        storedProcStatusText.setBackground(javax.swing.UIManager.getDefaults().getColor("Panel.background"));
        storedProcStatusText.setColumns(20);
        storedProcStatusText.setEditable(false);
        storedProcStatusText.setFont(storedProcStatusText.getFont());
        storedProcStatusText.setLineWrap(true);
        storedProcStatusText.setRows(5);
        storedProcStatusText.setToolTipText(org.openide.util.NbBundle.getMessage(StoredProceduresPanel.class, "StoredProceduresPanel.storedProcStatusText.toolTipText")); // NOI18N
        storedProcStatusText.setName("storedProcStatusText"); // NOI18N
        jScrollPane3.setViewportView(storedProcStatusText);
        storedProcStatusText.getAccessibleContext().setAccessibleName(org.openide.util.NbBundle.getMessage(StoredProceduresPanel.class, "StoredProceduresPanel.storedProcStatusText.AccessibleContext.accessibleName")); // NOI18N
        storedProcStatusText.getAccessibleContext().setAccessibleDescription(org.openide.util.NbBundle.getMessage(StoredProceduresPanel.class, "StoredProceduresPanel.storedProcStatusText.AccessibleContext.accessibleDescription")); // NOI18N

        catalogPatternLabel.setLabelFor(catalogPatternTextField);
        org.openide.awt.Mnemonics.setLocalizedText(catalogPatternLabel, org.openide.util.NbBundle.getMessage(StoredProceduresPanel.class, "StoredProceduresPanel.catalogPatternLabel.text")); // NOI18N
        catalogPatternLabel.setName("catalogPatternLabel"); // NOI18N

        catalogPatternTextField.setText(org.openide.util.NbBundle.getMessage(StoredProceduresPanel.class, "StoredProceduresPanel.catalogPatternTextField.text")); // NOI18N
        catalogPatternTextField.setName("catalogPatternTextField"); // NOI18N
        catalogPatternTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                catalogPatternTextFieldActionPerformed(evt);
            }
        });

        org.openide.awt.Mnemonics.setLocalizedText(catalogPatternNull, org.openide.util.NbBundle.getMessage(StoredProceduresPanel.class, "StoredProceduresPanel.catalogPatternNull.text")); // NOI18N
        catalogPatternNull.setName("catalogPatternNull"); // NOI18N
        catalogPatternNull.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                catalogPatternNullActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, storedProcEditorLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 512, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, jScrollPane5, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 512, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 512, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, jScrollPane3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 512, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, btnSelectStoredProc)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, procListLabel1)
                            .add(layout.createSequentialGroup()
                                .add(lblSelectedProcName, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 292, Short.MAX_VALUE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                                    .add(lblProcNumResultsets, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 92, Short.MAX_VALUE)
                                    .add(lblProcNumParameters, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 92, Short.MAX_VALUE))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                                    .add(editParamsButton, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 118, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(btnEditResultsets)))
                            .add(org.jdesktop.layout.GroupLayout.LEADING, statusLabel)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                                    .add(org.jdesktop.layout.GroupLayout.LEADING, catalogPatternLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .add(org.jdesktop.layout.GroupLayout.LEADING, procedureNamePatternLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                                    .add(catalogPatternTextField)
                                    .add(procedureNamePatternTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 170, Short.MAX_VALUE))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(layout.createSequentialGroup()
                                        .add(59, 59, 59)
                                        .add(searchProceduresButton))
                                    .add(catalogPatternNull))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 34, Short.MAX_VALUE))
                            .add(org.jdesktop.layout.GroupLayout.LEADING, btnRemoveSP))
                        .addContainerGap())
                    .add(procListLabel)))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(storedProcEditorLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 44, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(18, 18, 18)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(catalogPatternLabel)
                    .add(catalogPatternTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(catalogPatternNull))
                .add(18, 18, 18)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(procedureNamePatternLabel)
                    .add(procedureNamePatternTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(searchProceduresButton))
                .add(11, 11, 11)
                .add(procListLabel)
                .add(18, 18, 18)
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 87, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(btnSelectStoredProc)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(procListLabel1)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jScrollPane5, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 85, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(19, 19, 19)
                .add(btnRemoveSP)
                .add(18, 18, 18)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(editParamsButton)
                            .add(lblProcNumParameters))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 7, Short.MAX_VALUE)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(btnEditResultsets)
                            .add(lblProcNumResultsets)))
                    .add(lblSelectedProcName, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 53, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(statusLabel)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jScrollPane3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 61, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(35, 35, 35))
        );

        procedureNamePatternLabel.getAccessibleContext().setAccessibleDescription(org.openide.util.NbBundle.getMessage(StoredProceduresPanel.class, "StoredProceduresPanel.procedureNamePatternLabel.AccessibleContext.accessibleDescription")); // NOI18N
        searchProceduresButton.getAccessibleContext().setAccessibleDescription(org.openide.util.NbBundle.getMessage(StoredProceduresPanel.class, "StoredProceduresPanel.searchProceduresButton.AccessibleContext.accessibleDescription")); // NOI18N
        btnSelectStoredProc.getAccessibleContext().setAccessibleName(org.openide.util.NbBundle.getMessage(StoredProceduresPanel.class, "StoredProceduresPanel.btnSelectStoredProc.AccessibleContext.accessibleName")); // NOI18N
        btnSelectStoredProc.getAccessibleContext().setAccessibleDescription(org.openide.util.NbBundle.getMessage(StoredProceduresPanel.class, "StoredProceduresPanel.btnSelectStoredProc.AccessibleContext.accessibleDescription")); // NOI18N
        btnRemoveSP.getAccessibleContext().setAccessibleDescription(org.openide.util.NbBundle.getMessage(StoredProceduresPanel.class, "StoredProceduresPanel.btnRemoveSP.AccessibleContext.accessibleDescription")); // NOI18N
        editParamsButton.getAccessibleContext().setAccessibleName(org.openide.util.NbBundle.getMessage(StoredProceduresPanel.class, "StoredProceduresPanel.editParamsButton.AccessibleContext.accessibleName")); // NOI18N
        btnEditResultsets.getAccessibleContext().setAccessibleDescription(org.openide.util.NbBundle.getMessage(StoredProceduresPanel.class, "StoredProceduresPanel.btnEditResultsets.AccessibleContext.accessibleDescription")); // NOI18N
        catalogPatternLabel.getAccessibleContext().setAccessibleDescription(org.openide.util.NbBundle.getMessage(StoredProceduresPanel.class, "StoredProceduresPanel.catalogPatternLabel.AccessibleContext.accessibleDescription")); // NOI18N
        catalogPatternNull.getAccessibleContext().setAccessibleDescription(org.openide.util.NbBundle.getMessage(StoredProceduresPanel.class, "StoredProceduresPanel.catalogPatternNull.AccessibleContext.accessibleDescription")); // NOI18N
    }// </editor-fold>//GEN-END:initComponents

private void btnSelectStoredProcActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSelectStoredProcActionPerformed
    //Allow only single selection for now.
    if ((this.storedProcTable.getSelectedRow() != -1) && (this.selectedProcList.size() < 1)) {
        String storedProcName = getSelectedProcName();
        String catalog = getSelectedProcCatalog();
        String schema = getSelectedProcSchema();
        String storedProcType = getSelectedProcType();
        addStoredProcToList(storedProcName, catalog, schema, storedProcType);
    } else {
        if (this.selectedProcList.size() > 0) {
            storedProcStatusText.setText("Only single stored procedure is supported. \n Please remove the existing procedure and add again");
        }
    }

}//GEN-LAST:event_btnSelectStoredProcActionPerformed
    private String getSelectedProcName() {
        return (String) storedProcTableListModel.getValueAt(this.storedProcTable.getSelectedRow(), 0);
    }

    private String getSelectedProcCatalog() {
        return (String) storedProcTableListModel.getValueAt(this.storedProcTable.getSelectedRow(), 1);
    }

    private String getSelectedProcSchema() {
        return (String) storedProcTableListModel.getValueAt(this.storedProcTable.getSelectedRow(), 2);
    }

    private String getSelectedProcType() {
        return (String) storedProcTableListModel.getValueAt(this.storedProcTable.getSelectedRow(), 3);
    }

private void editParamsButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_editParamsButtonActionPerformed
    Procedure p = getCurrentProcedureSelected();
    if (p != null) {
        Dialog parent = (Dialog) SwingUtilities.getRoot(this.getComponent());
        ProcedureParametersDialog dlg = getProcedureParametersDialog();
        dlg.setSelectedProc(p);
        Utils.centerWindowOnScreen(dlg);
        dlg.setVisible(true);
    }
}//GEN-LAST:event_editParamsButtonActionPerformed

private void btnRemoveSPActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnRemoveSPActionPerformed
    removeStoredProcFromList();
    fireChangeEvent();
}//GEN-LAST:event_btnRemoveSPActionPerformed

private void btnEditResultsetsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnEditResultsetsActionPerformed
    Procedure p = getCurrentProcedureSelected();
    if (p != null) {
        Dialog parent = (Dialog) SwingUtilities.getRoot(this.getComponent());
        ProcedureResultsetDialog dlg = getProcedureResultsetDialog();
        dlg.setSelectedProc(p);
        dlg.setResultsetColumnsList(p.getResultSetColumns());
        Utils.centerWindowOnScreen(dlg);
        dlg.setVisible(true);

    }
}//GEN-LAST:event_btnEditResultsetsActionPerformed

private void searchProceduresButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_searchProceduresButtonActionPerformed
    try {
        setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
        storedProcTableListModel.getDataVector().removeAllElements();
        storedProcTableListModel.fireTableDataChanged();
    } finally {
        setCursor(Cursor.getDefaultCursor());
    }
    //To give time to clear the table, run load procedures later.
    SwingUtilities.invokeLater(new Runnable() {

        public void run() {
            try {
                setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
                loadProcList(procedureNamePatternTextField.getText(),catalogPatternTextField.getText(),catalogPatternNull.isSelected());
            } finally {
                setCursor(Cursor.getDefaultCursor());
            }
        }
    });

    
}//GEN-LAST:event_searchProceduresButtonActionPerformed

private void catalogPatternTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_catalogPatternTextFieldActionPerformed
    // TODO add your handling code here:
}//GEN-LAST:event_catalogPatternTextFieldActionPerformed

private void catalogPatternNullActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_catalogPatternNullActionPerformed
    // TODO add your handling code here:
    if(catalogPatternNull.isSelected()){
        catalogPatternTextField.setEnabled(false);
    } else {
        catalogPatternTextField.setEnabled(true);
    }

}//GEN-LAST:event_catalogPatternNullActionPerformed

    private Procedure getCurrentProcedureSelected() {
        Procedure p = null;

        // find the current selected row
        int i = tblSelectedStoredProcs.getSelectedRow();
        if (i > -1) {
            // generate the key to get the procedure from the hashtable
            String name = (String) tblSelectedStoredProcs.getValueAt(i, 0);
            String catalog = (String) tblSelectedStoredProcs.getValueAt(i, 1);
            String schema = (String) tblSelectedStoredProcs.getValueAt(i, 2);
            String type = (String) tblSelectedStoredProcs.getValueAt(i, 3);
            String key = Utils.getKey(catalog, schema, name, type);

            p = (Procedure) selectedProcList.get(key);
        }
        return p;
    }

    private void addStoredProcToList(String spName, String catalog, String schema, String procType) {
        try {
            String key = Utils.getKey(catalog, schema, spName, procType);
            Procedure newProc = (Procedure) selectedProcList.get(key);
            if (newProc == null) {
                try {
                    setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
                    newProc = DBMetaData.getProcedureMetaData(catalog, schema, spName, procType, dbConn.getJDBCConnection());
                } finally {
                    setCursor(Cursor.getDefaultCursor());
                }

                selectedProcList.put(key, newProc);
                addProcedure(newProc);
                //selectedStoredProcsModel.addRow(new Object[]{spName, catalog, schema, procType});
                int lastRow = tblSelectedStoredProcs.getRowCount() - 1;
                //tblSelectedStoredProcs.setRowSelectionInterval(lastRow, lastRow);
                //String paramsText = NbBundle.getMessage(StoredProceduresPanel.class, "StoredProceduresPanel.procNumParametersLabel.text");
                //String resultsetText = NbBundle.getMessage(StoredProceduresPanel.class, "StoredProceduresPanel.procNumResultsetsLabel.text");
                //lblProcNumParameters.setText(Utils.replaceAllChars(paramsText, '0', String.valueOf(newProc.getNumParameters())));
                //lblProcNumResultsets.setText(Utils.replaceAllChars(resultsetText, '0', String.valueOf(newProc.getResultSetColumns().size())));
                updateDescription(newProc);
                enableButtons();
                // now make sure this newly added row is visible - scroll to it
                java.awt.Rectangle rect = tblSelectedStoredProcs.getCellRect(lastRow, 0, true);
                scrollRectToVisible(rect);
            }
            //isValid();
            fireChangeEvent();

        } catch (Exception ex) {
            storedProcStatusText.setText(ex.getLocalizedMessage());
            ErrorManager.getDefault().log(ErrorManager.ERROR, ex.getMessage());
            ErrorManager.getDefault().notify(ErrorManager.ERROR, ex);
        }
    }

    /**
     * Adds a procedure to the selected list - for Edit button
     *
     * @param Procedure
     */
    public void addProcedure(Procedure p) {
        if (null != p) {
            String key = Utils.getKey(p.getCatalog(), p.getSchema(), p.getName(), p.getType());
            //get procedure resultsets and add it.
            ArrayList rs = getProcResultsets(p);
            selectedProcList.put(key, p);

            // add it to the selected table
            String[] procInfo = {p.getName(), p.getCatalog(), p.getSchema(), p.getType()};
            DefaultTableModel dm = (DefaultTableModel) tblSelectedStoredProcs.getModel();
            dm.addRow(procInfo);

            // select the last row which should be what we just added
            int lastRow = tblSelectedStoredProcs.getRowCount() - 1;
            tblSelectedStoredProcs.setRowSelectionInterval(lastRow, lastRow);

        }
    }

    private ArrayList<ResultSetColumns> getProcResultsets(Procedure p) {
        ArrayList resultSetColumnsList = new ArrayList();

        try {
            discoverResultsets(p);
            // retrieve the array of ResultSetColumns objects
            ResultSetColumns[] result = p.getResultSetColumnsArray();
            // get the count of resultsets
            int numResultSets = result.length;
            int numRSCols = 0;

            // check if the ResultSetColumns array holds any valid ResultSetColumn objects
            for (int i = 0; i < numResultSets; i++) {
                numRSCols += result[i].getNumColumns();
            }

            // if the procedure does not return any resultsets
            if (numRSCols > 0) {
                for (int i = 0; i < numResultSets; i++) {
                    // add the resultset object to the hashtable
                    resultSetColumnsList.add(result[i]);
                }
            }
        } catch (NullPointerException npe) {
            ErrorManager.getDefault().log(npe.getLocalizedMessage());
            ErrorManager.getDefault().notify(npe);
        }
        return resultSetColumnsList;

    }

    private void removeStoredProcFromList() {
        try {
            // get the selected row
            int selRow = tblSelectedStoredProcs.getSelectedRow();
            if (selRow > -1) {
                // generate the key to remove it from the selection hashtable
                String proc = (String) tblSelectedStoredProcs.getValueAt(selRow, 0);
                String catalog = (String) tblSelectedStoredProcs.getValueAt(selRow, 1);
                String schema = (String) tblSelectedStoredProcs.getValueAt(selRow, 2);
                String type = (String) tblSelectedStoredProcs.getValueAt(selRow, 3);
                String key = Utils.getKey(catalog, schema, proc, type);
                selectedProcList.remove(key);
                resultsetMap.clear();

                // remove this row from the table model
                selectedStoredProcsModel.removeRow(selRow);

                // now select the next row or previous row if any
                int newRow = -1;
                if (selRow < tblSelectedStoredProcs.getRowCount()) {
                    // select the next row following the deleted one
                    newRow = selRow;
                } else {
                    // select the previous row since the deleted one was
                    // the last row
                    newRow = selRow - 1;
                }

                if (newRow > -1) {
                    // there are still row(s) to select, so select it
                    tblSelectedStoredProcs.setRowSelectionInterval(newRow, newRow);
                    Procedure p = getCurrentProcedureSelected();
                    updateDescription(p);
                } else {
                    // no more rows in the table, clear the description fields
                    clearDescriptionFields();
                }
            }
            //isValid();
            fireChangeEvent();
        } catch (Exception ex) {
            storedProcStatusText.setText(ex.getLocalizedMessage());
            ErrorManager.getDefault().log(ErrorManager.ERROR, ex.getMessage());
            ErrorManager.getDefault().notify(ErrorManager.ERROR, ex);
        }
    }

    public void clearDescriptionFields() {
        lblSelectedProcName.setText("");
        lblProcNumParameters.setText("");
        lblProcNumResultsets.setText("");
        storedProcStatusText.setText("");
        enableButtons();
    }

    private void enableButtons() {
        // enable/disable buttons based on procedure selected
        if (tblSelectedStoredProcs.getSelectedRow() > -1) {
            // enable buttons
            editParamsButton.setEnabled(true);
            btnRemoveSP.setEnabled(true);
        } else {
            // disable buttons
            editParamsButton.setEnabled(false);
            btnEditResultsets.setEnabled(false);
            btnRemoveSP.setEnabled(false);
            lblProcNumParameters.setText(NbBundle.getMessage(StoredProceduresPanel.class, "StoredProceduresPanel.lblProcNumParameters.text"));
            lblProcNumResultsets.setText(NbBundle.getMessage(StoredProceduresPanel.class, "StoredProceduresPanel.lblProcNumResultsets.text"));
            lblSelectedProcName.setText("");

        }
    }

    private void updateDescription(Procedure p) {
        // updates the description panel fields with the procedure p's information
        ResultSetColumns[] result = null;
        result = p.getResultSetColumnsArray();
        int rsCount = result.length;

        lblSelectedProcName.setText(p.getName());
        String selText = NbBundle.getMessage(StoredProceduresPanel.class, "StoredProceduresPanel.lblProcNumParameters.text");
        selText = Utils.replaceAllChars(selText, '0', String.valueOf(p.getNumParameters()));
        lblProcNumParameters.setText(selText);
        selText = NbBundle.getMessage(StoredProceduresPanel.class, "StoredProceduresPanel.lblProcNumResultsets.text");
        selText = Utils.replaceAllChars(selText, '0', String.valueOf(rsCount));
        lblProcNumResultsets.setText(selText);
        if (rsCount > 0) {
            btnEditResultsets.setEnabled(true);
        }
    }

    @Override
    public boolean isValid() {
        if (selectedProcList != null) {
            if (selectedProcList.size() > 0) {
                return true;
            }
        }
        return super.isValid();
    }

    private void loadProcList(String procedureNamePattern, String catalogPattern, boolean noCatalog) {
        try {
            storedProcStatusText.setText("");
            String[][] procs = null;
            if(noCatalog){
            	catalogPattern = "";
            }
            if(noCatalog == false && catalogPattern.equalsIgnoreCase("")){
                catalogPattern = null;
            }
            if ((dbConn != null) && (dbConn.getJDBCConnection() != null)) {
                procs = DBMetaData.getProcedures(catalogPattern, dbConn.getSchema(), procedureNamePattern, dbConn.getJDBCConnection());
                if (procs != null) {
                    for (int i = 0; i < procs.length; i++) {
                        String[] procedureItem = procs[i];
                        storedProcTableListModel.addRow(new Object[]{procedureItem[DBMetaData.NAME],
                                    procedureItem[DBMetaData.CATALOG],
                                    procedureItem[DBMetaData.SCHEMA],
                                    procedureItem[DBMetaData.TYPE]
                                });
                    }
                } else {
                    storedProcStatusText.setText("No stored procedures/functions exist in the schema selected");
                }

            }
            enableButtons();
        } catch (SQLException sqle) {
            storedProcStatusText.setText("Error getting list of Stored Procedures:" + sqle.getMessage());
            ErrorManager.getDefault().log(ErrorManager.ERROR, sqle.getMessage());
            ErrorManager.getDefault().notify(ErrorManager.ERROR, sqle);

        } catch (Exception ex) {
            storedProcStatusText.setText(ex.getMessage());
            ErrorManager.getDefault().log(ErrorManager.ERROR, ex.getMessage());
            ErrorManager.getDefault().notify(ErrorManager.ERROR, ex);
        }
    }

    /**
     * Constructs an appropriate name for the resultset
     * ensuring that names are not duplicated
     *
     * @return String representation of the resultset name
     */
    private String createRSName() {
        // to store the highest index of resultset names
        int indexMax = 0;
        String tmpRSName = getSelectedProcName() + "_";

        int lenRSName = tmpRSName.length();

        // create an Integer array that contains the index part of resultset names
        // matching the pattern <<procedure name_index>>
        int[] arrRSNums = new int[resultsetMap.size()];

        if (resultsetMap.size() == 0) {
            return tmpRSName.concat(String.valueOf(indexMax));
        }

        for (int i = 0; i < resultsetMap.size(); i++) {
            String cboSelName = resultsetMap.get(i).getName();
            if (cboSelName.length() <= lenRSName) {
                continue;
            }
            String tmpSelName = cboSelName.substring(0, lenRSName);

            if (tmpSelName.equals(tmpRSName)) {
                String rsNum = cboSelName.substring(cboSelName.length() - 1);
                arrRSNums[i] = Integer.parseInt(rsNum);
            }
        }

        if (arrRSNums.length == 0) {
            return tmpRSName.concat(String.valueOf(indexMax));
        }

        // retrieve the highest index value stored in the array
        for (int i = 0; i < arrRSNums.length; i++) {
            int tmp = arrRSNums[i];
            if (tmp >= indexMax) {
                indexMax = tmp;
            }
        }

        indexMax += 1;
        return tmpRSName.concat(String.valueOf(indexMax));
    }
    /*
     *
     * Executes the stored procedure and obtains the resultsets
     */

    private void discoverResultsets(Procedure storedProc) {
        String colName = "%";
        int numResultSets = 0;  // hold the count of resultsets

        int numRSCols = 0;      // hold the number of resultset columns

        ResultSetColumns[] result = null;
        Procedure proc = null;
        try {
            if (DBMetaData.getDBType(dbConn.getJDBCConnection()).equalsIgnoreCase(DBMetaData.SQLSERVER)||DBMetaData.getDBType(dbConn.getJDBCConnection()).equalsIgnoreCase(DBMetaData.SYBASE)) {
                proc = dbMeta.getSQLServerProcResultSetColumns(storedProc.getCatalog(),
                        storedProc.getSchema(),
                        storedProc.getName(),
                        colName,
                        dbConn.getJDBCConnection());

            } else if (DBMetaData.getDBType(dbConn.getJDBCConnection()).equalsIgnoreCase(DBMetaData.ORACLE)) {
                proc = dbMeta.getOracleProcResultSetColumns(storedProc,
                                                                colName,
                                                                dbConn.getJDBCConnection());

            } else if(DBMetaData.getDBType(dbConn.getJDBCConnection()).equalsIgnoreCase(DBMetaData.DB2)){
                proc = DBMetaData.getDB2ProcResultSetColumns(storedProc.getCatalog(),
                        storedProc.getSchema(),
                        storedProc.getName(),
                        colName,
                        dbConn.getJDBCConnection());
            }else {
                proc = DBMetaData.getProcResultSetColumns(storedProc.getCatalog(),
                        storedProc.getSchema(),
                        storedProc.getName(),
                        colName,
                        dbConn.getJDBCConnection());
            }
            // retrieve the array of ResultSetColumns objects
            result = proc.getResultSetColumnsArray();
            // get the count of resultsets
            numResultSets = result.length;

            // check if the ResultSetColumns array holds any valid ResultSetColumn objects
            for (int i = 0; i < numResultSets; i++) {
                numRSCols += result[i].getNumColumns();
            }

            // if the procedure does not return any resultsets
            if (numRSCols == 0) {
            } else {
                for (int i = 0; i < numResultSets; i++) {
                    // create the name of the resultset
                    //result[i].setName(createRSName());
                    // add the resultset object to the hashtable
                    resultsetMap.add(result[i]);
                }
                storedProc.setResultSetColumns(result);
            }
            storedProc.setCallableStmtString(proc.getCallableStmtString());
        } catch (SQLException e) {
            storedProcStatusText.setText(e.getLocalizedMessage());
        } catch (NullPointerException npe) {
            storedProcStatusText.setText(npe.getLocalizedMessage());
        } catch (Exception ex) {
           storedProcStatusText.setText(ex.getLocalizedMessage());
        }
    }

    private ProcedureParametersDialog getProcedureParametersDialog() {
        if (procedureParametersDialog == null) {
            Dialog parent = (Dialog) SwingUtilities.getRoot(this.getComponent());
            procedureParametersDialog = new ProcedureParametersDialog(parent, true);
        }
        procedureParametersDialog.setLocationRelativeTo(this);
        procedureParametersDialog.setCaller(this);
        procedureParametersDialog.setMetaDataObject(dbMeta);
        return procedureParametersDialog;
    }

    private ProcedureResultsetDialog getProcedureResultsetDialog() {
        if (procResultSetsDialog == null) {
            Dialog parent = (Dialog) SwingUtilities.getRoot(this.getComponent());
            procResultSetsDialog = new ProcedureResultsetDialog(parent, true);
        }
        procResultSetsDialog.setLocationRelativeTo(this);
        procResultSetsDialog.setCaller(this);
        procResultSetsDialog.setMetaDataObject(dbMeta);
        return procResultSetsDialog;
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnEditResultsets;
    private javax.swing.JButton btnRemoveSP;
    private javax.swing.JButton btnSelectStoredProc;
    private javax.swing.JLabel catalogPatternLabel;
    private javax.swing.JCheckBox catalogPatternNull;
    private javax.swing.JTextField catalogPatternTextField;
    private javax.swing.JButton editParamsButton;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JLabel lblProcNumParameters;
    private javax.swing.JLabel lblProcNumResultsets;
    private javax.swing.JLabel lblSelectedProcName;
    private javax.swing.JLabel procListLabel;
    private javax.swing.JLabel procListLabel1;
    private javax.swing.JLabel procedureNamePatternLabel;
    private javax.swing.JTextField procedureNamePatternTextField;
    private javax.swing.JButton searchProceduresButton;
    private javax.swing.JLabel statusLabel;
    private javax.swing.JLabel storedProcEditorLabel;
    private javax.swing.JTextArea storedProcStatusText;
    private javax.swing.JTable storedProcTable;
    private javax.swing.JTable tblSelectedStoredProcs;
    // End of variables declaration//GEN-END:variables

    public Component getComponent() {
        return this;
    }

    public HelpCtx getHelp() {
        return new HelpCtx(PreparedStatementPanel.class);
    }

    public void readSettings(Object settings) {
        WizardDescriptor wd = null;
        if (settings instanceof JDBCWizardContext) {
            final JDBCWizardContext wizardContext = (JDBCWizardContext) settings;
            wd = (WizardDescriptor) wizardContext.getProperty(JDBCWizardContext.WIZARD_DESCRIPTOR);

        } else if (settings instanceof WizardDescriptor) {
            wd = (WizardDescriptor) settings;
        }
	DatabaseConnection dbConnection = (DatabaseConnection)
                wd.getProperty(JDBCWizardContext.CONNECTION);
        if (dbConnection != null) {
            setConnection(dbConnection);
        }
    }

    public void fireChangeEvent() {
        Iterator it;

        if (isValid()) {
            mWizardPanel.fireChange();
        }

        synchronized (this.listeners) {
            it = new HashSet(this.listeners).iterator();
        }

        final ChangeEvent ev = new ChangeEvent(this);
        while (it.hasNext()) {
            ((ChangeListener) it.next()).stateChanged(ev);
        }
    }

    public void storeSettings(final Object settings) {
        WizardDescriptor wd = null;
        if (settings instanceof JDBCWizardContext) {
            final JDBCWizardContext wizardContext = (JDBCWizardContext) settings;
            wd = (WizardDescriptor) wizardContext.getProperty(JDBCWizardContext.WIZARD_DESCRIPTOR);

        } else if (settings instanceof WizardDescriptor) {
            wd = (WizardDescriptor) settings;
        }

        final Object selectedOption = wd.getValue();
        if (NotifyDescriptor.CANCEL_OPTION == selectedOption || NotifyDescriptor.CLOSED_OPTION == selectedOption) {
            return;
        }

        if (wd != null) {
            wd.putProperty(WizardConstants.PROCEDURES_SELECTED, new Boolean(true));
            wd.putProperty(JDBCWizardContext.SELECTEDPROCEDURES, selectedProcList);
        }
    }

    public void addChangeListener(ChangeListener l) {
        this.listeners.add(l);
    }

    public void removeChangeListener(ChangeListener l) {
        this.listeners.remove(l);
    }
}
